## mingw-w64-jasper-4.2.5-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
# Version 3.20 needed for cmake_path.
# Version 3.19 needed for file(REAL_PATH ...).
# Version 3.12 needed for FindJPEG imported targets.
# Version 3.10 needed for FindOpenGL imported targets.
# Version 3.1 needed for FindGLUT imported targets.

################################################################################
# Specify software and shared library version information.
################################################################################

# The major, minor, and micro version numbers of the project.
set(JAS_VERSION_MAJOR 4)
set(JAS_VERSION_MINOR 2)
set(JAS_VERSION_PATCH 5)

# The shared library versioning information.
# Guidelines on how to change this information can be found below.
# The shared library version was set to 7.0.0 for JasPer version 4.0.0.
set(JAS_SO_VERSION 7)
set(JAS_SO_MINOR 0)
set(JAS_SO_RELEASE 0)

# Guidelines for Updating the Shared Library Versioning Information
# =================================================================
#
# If the code did not change (e.g., only documentation was updated):
#     do not change the shared library versioning information.
# If the code changed and the binary interface for the library did not change
# from the previous release (e.g., most bug fixes):
#     increment JAS_SO_RELEASE.
# If the binary interface changed, but remains compatible with the previous
# release (e.g., only new functions were added):
#     - increment JAS_SO_MINOR; and
#     - set JAS_SO_RELEASE to 0.
# If the binary interface changed in a way that breaks compatibility with the
# previous release (e.g., a function was deleted):
#     - increment JAS_SO_VERSION; and
#     - set both JAS_SO_MINOR and JAS_SO_RELEASE to 0.

# Generate the project version.
set(JAS_VERSION
	"${JAS_VERSION_MAJOR}.${JAS_VERSION_MINOR}.${JAS_VERSION_PATCH}")

# Generate the shared library build version.
set(JAS_SO_NAME "${JAS_SO_VERSION}.${JAS_SO_MINOR}.${JAS_SO_RELEASE}")

message("Software version: ${JAS_VERSION}")
message("Shared library ABI version: ${JAS_SO_VERSION}")
message("Shared library build version: ${JAS_SO_NAME}")

message("CMAKE_VERSION: ${CMAKE_VERSION}")

project(JasPer VERSION ${JAS_VERSION} LANGUAGES C)

message("CMAKE_C_COMPILER_ID: ${CMAKE_C_COMPILER_ID}")
message("CMAKE_C_COMPILER_VERISON: ${CMAKE_C_COMPILER_VERSION}")

################################################################################
# Include modules and set policies.
################################################################################

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/build/cmake/modules)

# This include should be placed as early as possible.
include(InSourceBuild)

include(CheckCCompilerFlag)
include(EnableAssertions)

# Adhere to GNU filesystem layout conventions.
include(GNUInstallDirs)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(CTest)
include(Sanitizers)
include(GenerateExportHeader)
include(JasGetIncludes)

# Note: JasGetStdcVersion uses try_run.
include(JasGetStdcVersion)
include(JasCheckType)

# Save some typing below.
function(add_c_compile_options args)
	foreach(arg IN LISTS ARGV)
		add_compile_options($<$<COMPILE_LANGUAGE:C>:${arg}>)
	endforeach()
endfunction()

################################################################################
# Define options.
################################################################################

# Note: The variable JAS_CROSSCOMPILING can be defined on the command line
# in order to override the value of CMAKE_CROSSCOMPILING (if necessary).

if(DEFINED BUILD_SHARED_LIBS)
	option(JAS_ENABLE_SHARED "Enable building of shared library"
	  ${BUILD_SHARED_LIBS})
else()
	option(JAS_ENABLE_SHARED "Enable building of shared library" ON)
endif()

option(JAS_PACKAGING "Enable packaging mode (e.g., disable RPATH)" OFF)

option(JAS_ENABLE_PIC "Enable position-independent code" ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ${JAS_ENABLE_PIC})

option(JAS_ENABLE_HIDDEN "Hide internal symbols" ON)
option(JAS_ENABLE_32BIT "Use a word size of 32 bits (instead of 64 bits) for fixed-point representations" OFF)
option(JAS_ENABLE_LIBJPEG "Enable the use of the JPEG Library" ON)
option(JAS_ENABLE_LIBHEIF "Enable the use of the HEIF Library" ON)
option(JAS_ENABLE_OPENGL "Enable the use of the OpenGL/GLUT Library" ON)
option(JAS_ENABLE_DOC "Enable building of the documentation" ON)
option(JAS_ENABLE_LATEX "Allow the use of LaTeX if it is available" ON)
option(JAS_ENABLE_PROGRAMS "Enable building of the programs" ON)
option(JAS_ENABLE_MULTITHREADING_SUPPORT "Enable multithreading support" ON)
option(JAS_PREFER_PTHREAD
  "Prefer POSIX Threads Library (over C11) for threading support" ON)
option(JAS_PREFER_PTHREAD_TSS
  "Prefer POSIX Threads Library thread-specific storage (over _Thread_local)"
  OFF)
option(JAS_STRICT "Treat compiler warnings as errors" OFF)

# Options controlling which codec support is built into the JasPer library.
option(JAS_INCLUDE_BMP_CODEC "Include (native) BMP codec support" ON)
option(JAS_INCLUDE_JP2_CODEC "Include (native) JP2 codec support" ON)
option(JAS_INCLUDE_JPC_CODEC "Include (native) JPC codec support" ON)
option(JAS_INCLUDE_JPG_CODEC
  "Include JPG codec support (via IJG JPEG Library)" ON)
option(JAS_INCLUDE_HEIC_CODEC
  "Include experimental HEIC codec support (via Libheif Library)" ON)
option(JAS_INCLUDE_MIF_CODEC "Include (native) MIF codec support" ON)
option(JAS_INCLUDE_PGX_CODEC "Include (native) PGX codec support" ON)
option(JAS_INCLUDE_PNM_CODEC "Include (native) PNM codec support" ON)
option(JAS_INCLUDE_RAS_CODEC "Include (native) RAS codec support" ON)

# Options controlling which codec support that is built into the JasPer
# library is enabled by default.
option(JAS_ENABLE_BMP_CODEC "Enable (native) BMP codec support" ON)
option(JAS_ENABLE_JP2_CODEC "Enable (native) JP2 codec support" ON)
option(JAS_ENABLE_JPC_CODEC "Enable (native) JPC codec support" ON)
option(JAS_ENABLE_JPG_CODEC
  "Enable JPG codec support (via IJG JPEG Library)" ON)
option(JAS_ENABLE_HEIC_CODEC
  "Enable experimental HEIC codec support (via Libheif Library)" OFF)
option(JAS_ENABLE_MIF_CODEC "Enable (native) MIF codec support" OFF)
option(JAS_ENABLE_PGX_CODEC "Enable (native) PGX codec support" ON)
option(JAS_ENABLE_PNM_CODEC "Enable (native) PNM codec support" ON)
option(JAS_ENABLE_RAS_CODEC "Enable (native) RAS codec support" ON)

set(JAS_DEFAULT_MAX_MEM_USAGE "1073741824" CACHE STRING
  "Set memory usage limit in bytes")

# The following options are for testing/debugging and should normally only
# be changed by the developers of JasPer.
option(JAS_USE_JAS_INIT
  "Use jas_init instead of jas_init_custom for initialization (should be false, except for testing)"
  OFF)
option(JAS_ENABLE_NON_THREAD_SAFE_DEBUGGING
  "Enable non-thread safe debug code" OFF)

if(JAS_USE_JAS_INIT)
	add_compile_definitions(JAS_USE_JAS_INIT)
endif()

# To override the default setting of max_align_t, something like what
# appears in the body of the if-statement following this comment can be used.
# WARNING: Do not do this unless you know what you are doing.
if(FALSE)
	add_compile_definitions("JAS_NO_SET_MAX_ALIGN_T")
	add_compile_definitions("max_align_t=__INSERT_APPROPRIATE_TYPE_HERE__")
endif()

# To override the default setting of ssize_t, something like what
# appears in the body of the if-statement following this comment can be used.
# WARNING: Do not do this unless you know what you are doing.
if(FALSE)
	add_compile_definitions("JAS_NO_SET_SSIZE_T")
	add_compile_definitions("ssize_t=__INSERT_APPROPRIATE_TYPE_HERE__")
endif()

# WARNING: THE FOLLOWING OPTION SHOULD ONLY BE ENABLED BY THE JASPER SOFTWARE
# DEVELOPMENT TEAM.  IT IS NECESSARY FOR INTERNAL TESTING PURPOSES AND POSES
# SIGNIFICANT SECURITY RISKS IF ENABLED.
option(JAS_ENABLE_DANGEROUS_INTERNAL_TESTING_MODE
  "DO NOT ENABLE FOR SECURITY REASONS! (For internal use by JasPer development team only"
  OFF)

option(JAS_ENABLE_CXX "Enable C++ code (for testing)." OFF)
option(JAS_ENABLE_CONFORMANCE_TESTS "Enable conformance tests." OFF)

option(JAS_WASM "Enable WebAssembly mode" OFF)
if(JAS_WASM)
	set(JAS_CROSSCOMPILING 1)
	set(JAS_STDC_VERSION "201112L")
	set(JAS_ENABLE_MULTITHREADING_SUPPORT 0)
	set(JAS_ENABLE_SHARED 0)
	set(JAS_USE_JAS_INIT 0)
	add_compile_definitions(JAS_WASI_LIBC)
endif()

################################################################################
#
################################################################################

if(JAS_ENABLE_CXX)
	message("Enabling C++")
	enable_language(CXX)
	message("CMAKE_CXX_COMPILER_ID: ${CMAKE_CXX_COMPILER_ID}")
	message("CMAKE_CXX_COMPILER_VERSION: ${CMAKE_CXX_COMPILER_VERSION}")
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

# It is strongly recommended that the JasPer software be built using a
# compiler that supports the C11 (or later) version of the C standard, if
# such a compiler is available.  The use of compilers supporting older
# versions of the language standard, such as C99, should only be used when
# no C11 support is available.
#set(CMAKE_C_STANDARD 99) # This should work but is not recommended.
set(CMAKE_C_STANDARD 11)

# Enable extensions so that POSIX support is visible (e.g., ssize_t) without
# having to manually define _POSIX_C_SOURCE.
# Setting this to OFF will break things for at least some versions of MacOS
# (e.g, due to u_char, u_short, and u_int being undefined).
# In any case, it might be a bad idea to set this to OFF due to issues
# related to max_align_t and ssize_t.
set(CMAKE_C_EXTENSIONS ON)

# Ensure that that the try_compile command (and the commands that use it)
# use the compiler option for the language standard being used.
# This policy was added in CMake 3.8.
cmake_policy(SET CMP0067 NEW)

if(JAS_ENABLE_CXX)
	set(CMAKE_CXX_STANDARD 11)
	set(CMAKE_CXX_EXTENSIONS ON)
endif()

# Eliminate a CMake warning.
# Note: This policy was added in CMake 3.20.  Do not add this for now,
# since it will cause older versions of CMake to barf.
#cmake_policy(SET CMP0115 NEW)

if(APPLE AND CMAKE_SYSTEM_NAME MATCHES "Darwin")
	set(MACOS TRUE)
else()
	set(MACOS FALSE)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(LINUX TRUE)
else()
	set(LINUX FALSE)
endif()

if((CMAKE_GENERATOR MATCHES "Xcode") OR
  (CMAKE_GENERATOR MATCHES "Visual Studio") OR
  (CMAKE_GENERATOR STREQUAL "Ninja Multi-Config"))
	set(JAS_MULTICONFIGURATION_GENERATOR TRUE)
	message("JAS_MULTICONFIGURATION_GENERATOR ${JAS_MULTICONFIGURATION_GENERATOR}")
else()
	set(JAS_MULTICONFIGURATION_GENERATOR FALSE)
endif()
message("JAS_MULTICONFIGURATION_GENERATOR ${JAS_MULTICONFIGURATION_GENERATOR}")

# If a multiconfiguration generator is used, ensure that various output
# files are not placed in subdirectories (such as Debug and Release)
# as this will cause the CTest test suite to fail.
if(JAS_MULTICONFIGURATION_GENERATOR)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY .)
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY .)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY .)
	foreach(config ${CMAKE_CONFIGURATION_TYPES})
		string(TOUPPER "${config}" config)
		set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${config} .)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${config} .)
		set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${config} .)
	endforeach()
endif()

include(InstallRequiredSystemLibraries)
set(CPACK_PACKAGE_NAME "${CMAKE_PROJECT_NAME}")
set(CPACK_PACKAGE_VERSION "${JAS_VERSION}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "JasPer Image Processing Tool Kit")
set(CPACK_PACKAGE_VENDOR "Michael Adams")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt")
set(CPACK_PACKAGE_VERSION_MAJOR "${JAS_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${JAS_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${JAS_VERSION_PATCH}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY
  "CMake ${CMake_VERSION_MAJOR}.${CMake_VERSION_MINOR}")

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=jasper
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-docs")
pkgver=4.2.5
pkgrel=2
pkgdesc="Reference implementation of JPEG-2000 Part-1 codec (ISO/IEC 15444-5) (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
msys2_repository_url='https://github.com/jasper-software/jasper'
url="https://www.ece.uvic.ca/~mdadams/jasper"
msys2_references=(
  "cpe: cpe:2.3:a:jasper_project:jasper"
)
license=("spdx:JasPer-2.0")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
depends=("${MINGW_PACKAGE_PREFIX}-freeglut"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
source=(${_realname}-${pkgver}.tar.gz::https://github.com/jasper-software/jasper/archive/version-${pkgver}.tar.gz
        001-mingw-cmake.patch
        004-jasper-exports.patch
        005-fix-filename-buffer-overflow-msvcrt.patch)
sha256sums=('3f4b1df7cab7a3cc67b9f6e28c730372f030b54b0faa8548a9ee04ae83fffd44'
            '89f7653884c93e1cb32271c59213551d1231674bd12df00331c302971d5ac489'
            '0f9b9270edb3f19c08425d8e97588b4ebe6b494579e2b66bb14929d01c8b4059'
            '96db137a8eb657d1ee84339f3a8783637dbae8ebed5d32276ec8f76786fc1ab2')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "$srcdir"/${_realname}-version-${pkgver}

  apply_patch_with_msg \
    001-mingw-cmake.patch \
    004-jasper-exports.patch \
    005-fix-filename-buffer-overflow-msvcrt.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  msg2 "Building static library"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_INSTALL_LIBDIR=lib \
      ${_extra_config[@]} \
      -DJAS_ENABLE_OPENGL=OFF \
      -DJAS_ENABLE_LIBJPEG=ON \
      -DCMAKE_SKIP_RPATH=ON \
      -DJAS_ENABLE_SHARED=OFF \
      -S "${_realname}-version-${pkgver}" \
      -B "build-${MSYSTEM}-static"

  cmake --build "build-${MSYSTEM}-static"

  msg2 "Building shared library"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_INSTALL_LIBDIR=lib \
      ${_extra_config[@]} \
      -DJAS_ENABLE_OPENGL=OFF \
      -DJAS_ENABLE_LIBJPEG=ON \
      -DCMAKE_SKIP_RPATH=ON \
      -DJAS_ENABLE_SHARED=ON \
      -S "${_realname}-version-${pkgver}" \
      -B "build-${MSYSTEM}-shared"

  cmake --build "build-${MSYSTEM}-shared"
}

check() {
  cd "${srcdir}"/build-${MSYSTEM}-static
  ctest . || msg2 "tests failed"
}

package_jasper() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}-shared"

  install -Dm 644 "${srcdir}/${_realname}-version-${pkgver}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"

  # split docs
  mkdir -p dest${MINGW_PREFIX}/share
  mv "${pkgdir}${MINGW_PREFIX}"/share/doc dest${MINGW_PREFIX}/share/doc
}

package_jasper-docs() {
  pkgdesc+=" (documentation)"
  depends=()

  mv dest/* "${pkgdir}"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
